<template>
    <div class="app-container">
        <div class="filter-container">
            <el-row :gutter="20">
                <el-col :span="16" ref="filter" :model="filter">
                    <el-input prop="keyword" v-model="filter.keyword" ref="keyword" name="keyword" placeholder="Nama barang/jasa" style="width: 300px;" size="medium" class="filter-item" clearable @keyup.enter.native="handleSearch" @clear="handleSearch"/>
                    <el-button @click="handleSearch" size="mini" type="primary" class="filter-item">
                        <i class="ion-ios-search"></i> Cari
                    </el-button>
                </el-col>
            </el-row>            
        </div>
        <el-table v-loading="tableLoading" :data="products" ref="productTable" style="width: 100%" :height="tableHeight" fit highlight-current-row>
            <el-table-column
                fixed="left"
                label="Tanggal"
                width="150">
                <template slot-scope="scope">
                    {{ dateFormat(scope.row.updated) }}
                </template>
            </el-table-column>  
            <el-table-column
                align="center"
                label="Kondisi"
                width="100">
                <template slot-scope="scope">
                    <el-tag size="mini" type="success" v-if="scope.row.conditions == 'new'">Baru</el-tag>
                    <el-tag size="mini" type="info" v-if="scope.row.conditions == 'used'">Bekas</el-tag>
                </template>
            </el-table-column>         
            <el-table-column
                label="Nama Barang/Jasa"
                width="200">
                <template slot-scope="scope">
                    <span>{{ scope.row.title }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Deskripsi"
                width="350">
                <template slot-scope="scope">
                    <span>{{ truncate(scope.row.description) }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Kategori"
                width="150">
                <template slot-scope="scope">
                    <span>{{ scope.row.category.name }}</span>
                </template>
            </el-table-column> 
            <el-table-column
                label="Harga"
                width="150">
                <template slot-scope="scope">
                    <span>Rp {{ scope.row.price.format(0,0,'.',',') }}</span>
                </template>
            </el-table-column>           
            <el-table-column
                label="Author"
                width="150">
                <template slot-scope="scope">
                    <span>{{ scope.row.author.profile.fullname }}</span>
                </template>
            </el-table-column>            
            <el-table-column
                fixed="right"
                label="Tindakan"
                min-width="200">
                <template slot-scope="{row}">
                    <el-button v-permission="[row, 'product', 'viewown']" type="text" @click="handleView(row)">Lihat Detil</el-button>
                    <el-button v-permission="[row, 'product', 'deleteown']" type="text" class="text-danger" @click="handleDelete(row)">Hapus</el-button>
                </template>
            </el-table-column>
        </el-table>
        
        <pagination v-show="pagination.pages>1" :total="pagination.total" :page.sync="pagination.page" :perpage.sync="pagination.perpage" @pagination="handleSearch" />

        <el-dialog title="Detil Barang/Jasa" :visible.sync="showDialog" width="30%" :show-close="false">
            <el-carousel trigger="click" v-if="product.medias.length > 0">
                <el-carousel-item v-for="item in product.medias" :key="item.id">
                    <el-image
                    style="width: 100%"
                    :src="item.url.large"
                    fit="fit"></el-image>
                </el-carousel-item>
            </el-carousel>
            <h3>{{ product.title }}</h3>
            <small class="display-block">Terakhir diperbarui: {{ product.updated }}</small>
            <h2><s v-if="product.discount > 0">Rp {{ product.price }}</s> Rp {{ calculateDiscount(product.price, product.discount).format(0,0,'.',',') }} / {{ product.unit.name }}</h2>
            <span class="display-block margin-small-bottom padding-small-bottom" style="border-bottom: 1px dashed #ddd;">{{ product.description }}</span>
            <span v-if="product.store_open && product.store_close" class="display-block margin-small-bottom padding-small-bottom" style="border-bottom: 1px dashed #ddd;"><i class="el-icon-time"></i>  <strong> Buka</strong> dari <strong>{{ product.store_open }}</strong> sampai {{ product.store_close }}</span>
            <span class="display-block margin-small-bottom padding-small-bottom" style="border-bottom: 1px dashed #ddd;"><i class="el-icon-goods"></i>  Kondisi: <strong>{{ product.condition }}</strong></span>
            <span class="display-block margin-small-bottom padding-small-bottom" style="border-bottom: 1px dashed #ddd;"><i class="el-icon-s-order"></i>  Pesanan minimum: <strong>{{ product.minorder }} {{ product.unit.name }}</strong></span>
            <span v-if="product.delivery_cost > 0" class="display-block margin-small-bottom padding-small-bottom" style="border-bottom: 1px dashed #ddd;"><i class="el-icon-s-promotion"></i>  Pesan antar dikenakan biaya <strong>{{ product.delivery_cost.format(0,0,'.',',') }}</strong></span>
            <span class="display-block margin-small-bottom padding-small-bottom" style="border-bottom: 1px dashed #ddd;"><i class="el-icon-s-shop"></i> {{ product.store_name }}</span>
            <span slot="footer" class="dialog-footer">
                <el-button @click="showDialog = false" size="medium">Tutup</el-button>
            </span>
        </el-dialog>

    </div>
</template>
<script>
import { mapGetters } from 'vuex';
import permission from '@/directive/permission/index.js';
import Pagination from '@/components/Pagination';
import { parseError, playSound, dateFormat, tableHeight, truncate } from '@/utils/index';

export default {
    name: 'Product',
    components: {
        Pagination
    },
    directives: {
        permission
    },
    data(){
        return {
            tableLoading: false,
            showDialog: false,
            filter: {
                keyword: ''
            },
            product: {
                condition: '',
                title: '',
                description: '',
                category: '',
                updated: '',
                price: 0,
                discount: 0,
                minorder: 1,
                delivery_cost: 0,
                isnegotiable: false,
                isdeliverable: false,
                medias: [],
                unit: {},
                store_open: '',
                store_close: '',

            }
        };
    },
    computed: {
        tableHeight,
        ...mapGetters('auth', ['token']),
        ...mapGetters('user', ['me', 'users']),
        ...mapGetters('product', ['products', 'pagination']),
    },
    created() {
        this.getProducts();
    },
    methods: {
        playSound,
        dateFormat,
        truncate,
        calculateDiscount(price, discount){
            if(discount > 0){
                return price - (price * discount/100);
            }
            return price;
        },
        getProducts() {
            this.tableLoading = true;
            this.$store.dispatch('product/getProducts', {
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        handleSearch(){

            let payload = {
                q: this.filter.keyword,
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }

            this.tableLoading = true;
            this.$store.dispatch('product/getProducts', payload).then(() => {
                this.tableLoading = false;
            });
        },
        handleView(product){      
            const self = this; 

            self.product.condition = product.conditions == 'new' ? 'Baru' : 'Bekas';
            self.product.title = product.title;
            self.product.description = product.description;
            self.product.category = product.category.name;
            self.product.updated = dateFormat(product.updated);
            self.product.price = product.price;
            self.product.discount = product.discount;
            self.product.minorder = product.minorder;
            self.product.delivery_cost = product.delivery_cost;
            self.product.isnegotiable = product.isnegotiable;
            self.product.isdeliverable = product.isdeliverable;
            self.product.medias = product.medias;
            self.product.unit = product.unit;
            self.product.store_open = product.author.profile.store_open;
            self.product.store_close = product.author.profile.store_close;
            self.product.store_name = product.author.profile.store_name != null ? product.author.profile.store_name : product.author.profile.fullname;
            self.showDialog = true;
        },
        handleDelete(product){
            this.$confirm('Anda mencoba untuk menghapus data barang/jasa, data tidak bisa dikembalikan setelah dihapus. Anda yakin?', 'Peringatan', {
                confirmButtonText: 'Ya, Hapus',
                cancelButtonText: 'Batal'
            }).then(() => {
                this.tableLoading = true;
                this.$store.dispatch('product/deleteProduct', {
                    id: product.id
                }).then((response) => {
                    this.tableLoading = false;
                    if('errors' in response){
                        let error = parseError(response.errors);
                        this.$message.error({
                            message: error.messages
                        });
                    }else{
                        this.showDialog = false;
                        this.$message.success({
                            message: response.message
                        });
                    }

                    this.playSound();
                });
            });
        },
    }

}
</script>
